# User Guide

This section provides comprehensive guides for using the Monsoon Crop Predictor package.

```{toctree}
:maxdepth: 2

core_concepts
data_preparation
making_predictions
batch_processing
api_usage
cli_usage
advanced_features
troubleshooting
```

## Overview

The Monsoon Crop Predictor is designed to be easy to use while providing powerful capabilities for crop yield prediction. Whether you're a researcher, farmer, or data scientist, this guide will help you get the most out of the package.

## Key Components

- **Core Library**: The main prediction engine and data processing utilities
- **API Server**: RESTful API for web applications and microservices
- **CLI Tools**: Command-line interface for batch processing and automation
- **Models**: Pre-trained ensemble models for rice, wheat, and maize
